#include "TI82.H"
#include "KEYS.INC"

.ORG START_ADDR
.DB "ASCII Characters 82",0;It is compiled for ASH but runs with CrASH

VAL = TEXT_MEM		;For storing the value

 ROM_CALL(CLEARLCD)
 LD HL,0
 LD (CURSOR_POS),HL
 LD HL,Name
 ROM_CALL(D_ZT_STR)	;Title Screen
 CALL waitkey
 LD A,0
 LD (VAL),A
DrawChar:
 ROM_CALL(CLEARLCD)
 LD HL,$0003
 LD (CURSOR_POS),HL
 LD (VAL),A
 LD H,0
 LD L,A
 ROM_CALL(D_HL_DECI)	;Draws number
 LD HL,$0A03
 LD (CURSOR_POS),HL
 LD A,(VAL)
 ROM_CALL(TX_CHARPUT)	;Draws character to screen
Loop:
 CALL GET_KEY
 CP G_LEFT
 JR Z,leftchar
 CP G_RIGTH
 JR Z,rightchar
 CP G_UP
 JR Z,upchar
 CP G_DOWN		;Your basic key control
 JR Z,downchar
 CP G_2nd
 JR Z,showall
 CP G_MODE
 JR Z,endprgm
 JR Loop

leftchar:
 LD A,(VAL)
 DEC A
 LD (VAL),A		;decreases character by one - LEFT KEY
 JR DrawChar

rightchar:
 LD A,(VAL)
 INC A			;increases character by one - RIGHT KEY
 LD (VAL),A
 JR DrawChar

upchar:
 LD A,(VAL)
 LD B,10
djnzlp1:
 DEC A			;decreases character by ten - UP KEY
 DJNZ djnzlp1
 LD (VAL),A
 JR DrawChar

downchar:
 LD A,(VAL)
 LD B,10
djnzlp2:
 INC A			;increases character by ten - DOWN KEY
 DJNZ djnzlp2
 LD (VAL),A
 JR DrawChar

waitkey:
 CALL GET_KEY
 CP G_ENTER		;short routine to wait for the ENTER key
 JR NZ,waitkey
 RET

endprgm:
 ROM_CALL(CLEARLCD)
 LD HL,0
 LD (CURSOR_POS),HL	;routine that ends the program
 LD HL,Byebye
 ROM_CALL(D_ZT_STR)
 CALL waitkey
 RET

showall:		;LONG AND PAINFUL routine that displays all characters
 RES 2,(IY+$0D)		;So the window won't scroll when it reaches (7,15)
 ROM_CALL(CLEARLCD)
 LD E,0			;E is the character value (0-127)
 LD C,0			;C is the row you're on (0-7)
sal2:
 LD B,16		;B is for looping with djnz
 LD D,0			;D is the column (0-15)
sal1:
 LD A,D
 LD H,A			
 LD A,C			;CURSOR_POS(X,Y)=(D,C)
 LD L,A	;(could reduce?)
 LD (CURSOR_POS),HL
 LD A,E
 ROM_CALL(TX_CHARPUT)	;display character E
 INC D
 INC E			;increment D and E before looping
 djnz sal1
 INC C			;when done with that row, inc the row num
 LD A,C
 OR A
 CP 8
 JR NZ,sal2
 CALL waitkey		;wait before doing it again
 ROM_CALL(CLEARLCD)
 LD E,128		;E is the character value (128-255)
 LD C,0			;C is the row you're on (0-7)
sal4:
 LD B,16		;B is for looping with djnz
 LD D,0			;D is the column (0-15)
sal3:
 LD A,D
 LD H,A			
 LD A,C			;CURSOR_POS(X,Y)=(D,C)
 LD L,A	;(could reduce?)
 LD (CURSOR_POS),HL
 LD A,E
 ROM_CALL(TX_CHARPUT)	;display character E
 INC D
 INC E			;increment D and E before looping
 djnz sal3
 INC C			;when done with that row, inc the row num
 LD A,C
 OR A
 CP 8
 JR NZ,sal4
 CALL waitkey
 LD A,0
 LD (VAL),A		;sets character back to zero (otherwise it would have been 9)
 SET 2,(IY+$0D)		;Lets it scroll again (puts it back to normal)
 JP DrawChar

Name:
.DB "By Phil Software"
.DB "(Press Enter)",0

Byebye:
.DB "Bye Bye!",0

.END			;We're done!